=== debian/changelog ===
openmodelica (24183-1) unstable; urgency=low

  * Automatic subversion build
 -- OpenModelica Build System <build@openmodelica.org>  Sun, 25 Jan 2015 02:41:41 +0100
